\documentclass[a4paper]{article}
\usepackage[english]{babel}
\usepackage[T1]{fontenc}
\usepackage[a4paper, top=0.75cm, bottom=0.75cm, left=2cm, right=2cm]{geometry}
\usepackage{listings}
\usepackage{inconsolata}
\pagenumbering{gobble}
\lstset{frame=single, showstringspaces=false, columns=fixed, basicstyle={\ttfamily}, commentstyle={\it}, numbers=left, tabsize=4}
\begin{document}
\lstset{title=Contents of \texttt{README}}
\lstset{
  language=,
  morekeywords={NAME, SYNOPSIS, DESCRIPTION, NOTES, EXAMPLES, AUTHOR, COPYRIGHT},
  moredelim=[is][\it]{<|}{|>},
  moredelim=[is][\bf]{<:}{:>}
}
\begin{lstlisting}
NAME
        <:ticker:> - a library for processing aperiodic data with accumulative
        calculations and constant memory requirements.

        <:stdagent:> - a supplementary library, containing some common methods of
        data processing.

SYNOPSIS
        void <|tick|>(double val, <|TickState|> *st)
            Process the value val.
            The <|TickState|> sets the environment with which to process the data.

DESCRIPTION
        A <|TickState|> completely contains all the state needed for the operation
        of tick(). That is, hypothetically, tick() is thread safe and you can
        run multiple tickers concurrently, with each having its own <|TickState|>.
        The <|TickState|> struct has 3 field:
            time_t timer          - The internal timer, should be set to 0.
            time_t sec_per_tick   - The number of seconds in one tick.
            <|Actor|> (*actors)[]     - A pointer to an array of Actors.

        A null-terminated array of <|Actors|>, each <|Actor|> is a pair {agent, data}:
            agent *fun - a function, which performs the action.
            void *data - used to pass extra data and preserve state.

        Agents can be implemented by the user or included from <:stdagent.h:>
        <:stdagent.h:> provides the following agents:
            a_max       - Calculates the maximum of values.
            a_min       - Calculates the minimum of values.
            a_sum       - Calculates the sum of values.
            a_time      - Displays the timestamp of the first value.
            a_format    - Prints the string, located in its `void *data`.
            a_average   - Calculates the average of values.
            a_deviation - Calculates the standard deviation of values.
        All the <:stdagents:> require their `void *data` to be NULL, with the
        exception of a_format, which requires a null-terminated string.

NOTES
        Although it is possible to create tickers on demand during the execution
        of the program, it is recommended to have a constant number of them,
        because the contents of `void *data` of each agent can never be freed
        after they are allocated on the heap.

EXAMPLES
        Examples are available in src/examples.c

AUTHOR
        Implemented by Stotskii Andrey (ruro).

COPYRIGHT
        Copyright (c) 2017 Free Software Foundation, Inc.  License GPLv3+:
        GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
        This is free software: you are free to change and redistribute it.
        There is NO WARRANTY, to the extent permitted by law.
\end{lstlisting}
\lstset{language={[ANSI]C}}
\lstset{morekeywords={size_t, va_list, time_t, __attribute__}}
\lstset{title=Contents of \texttt{src/terminator.h}}
\begin{lstlisting}
#ifndef _TERMINATOR_H
#define _TERMINATOR_H

void terminate(int code, const char *fmt, ...)
    __attribute__ ((noreturn))
    __attribute__ ((format (printf, 2, 3)));

#endif
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/ticker.h}}
\begin{lstlisting}
#ifndef _TICKER_H
#define _TICKER_H
#include <time.h>

typedef enum
{
    ACCUMULATE,
    INSPECT,
    INIT
} Action;

typedef void agent(double, Action, void **);

typedef struct
{
    agent *fun;
    void *usr;
} Actor;

typedef struct
{
    time_t timer;
    time_t sec_per_tick;
    Actor (*actors)[];
} TickState;

void tick(double, TickState *);

#endif
\end{lstlisting}
\lstset{title=Contents of \texttt{src/stdagent.h}}
\begin{lstlisting}
#ifndef _STDAGENT_H
#define _STDAGENT_H
#include "ticker.h"

agent a_max;
agent a_min;
agent a_sum;
agent a_time;
agent a_format;
agent a_average;
agent a_deviation;

#endif
\end{lstlisting}
\lstset{title=Contents of \texttt{makefile}}
\lstset{language={[gnu]make}}
\begin{lstlisting}
CFLAGS= -Wall -O3
LDFLAGS= -lm
CC=gcc

vpath %.c src

examples: stdagent.o ticker.o terminator.o

.PHONY:libs
libs: stdagent.o ticker.o terminator.o

.PHONY:clean
clean:
	rm -f *.o examples
\end{lstlisting}
\newpage
\lstset{language={[ANSI]C}}
\lstset{morekeywords={size_t, va_list, time_t, __attribute__}}
\lstset{title=Contents of \texttt{src/ticker.c}}
\begin{lstlisting}
#include <time.h>

#include "ticker.h"

void tick(double val, TickState *st)
{
    time_t now = time(NULL);
    Action upd = ACCUMULATE;

    if (!st->timer)
    {
        st->timer = now;
        upd = INIT;
    }
    
    if (now/st->sec_per_tick > st->timer/st->sec_per_tick)
    {
        st->timer = now;
        upd = INSPECT;
    }

    Actor *act = *(st->actors);
    for (int i = 0; act[i].fun; i++)
        act[i].fun(val, upd, &act[i].usr);

}
\end{lstlisting}
\lstset{title=Contents of \texttt{src/terminator.c}}
\begin{lstlisting}
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "terminator.h"

void terminate(int code, const char *fmt, ...)
{
    // Print the formatted message.
    va_list args;
    va_start(args, fmt);
    vprintf(fmt, args);
    va_end(args);

    // Print the error message, if any.
    if (code)
        printf("Error: %s \n", strerror(code));

    exit(code);
}
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/stdagent.c}}
\begin{lstlisting}
#include <time.h>
#include <math.h>
#include <stdio.h>
#include <malloc.h>
#include <errno.h>

#include "stdagent.h"
#include "terminator.h"

typedef struct
{
    double avg;
    unsigned count;
} AverageAccumulator;

void accum_avg(AverageAccumulator *acc, double val)
{
    acc->avg = (acc->avg*acc->count + val)/(acc->count + 1);
    acc->count++;
}

void a_max(double val, Action act, void **data)
{
    double **max = (void *)data;
    
    if (act == INIT)
    {
        *max = malloc(sizeof(**max));
        if (!*max)
            terminate(errno, "Malloc failed.\n");
        **max = val;
    }
    
    if (act == INSPECT)
    {
        printf("%38s : %-38lf\n", "Maximum value", **max);
        **max = val;
    }
    
    **max = (**max > val) ? **max : val;
}

void a_min(double val, Action act, void **data)
{
    double **min = (void *)data;
    
    if (act == INIT)
    {
        *min = malloc(sizeof(**min));
        if (!*min)
            terminate(errno, "Malloc failed.\n");
        **min = val;
    }
    
    if (act == INSPECT)
    {
        printf("%38s : %-38lf\n", "Minimum value", **min);
        **min = val;
    }
    
    **min = (**min < val) ? **min : val;
}

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
void a_sum(double val, Action act, void **data)
{
    double **sum = (void *)data;
    
    if (act == INIT)
    {
        *sum = malloc(sizeof(**sum));
        if (!*sum)
            terminate(errno, "Malloc failed.\n");
        **sum = 0;
    }
    
    if (act == INSPECT)
    {
        printf("%38s : %-38lf\n", "Sum of values", **sum);
        **sum = 0;
    }
    
    **sum += val;
}

void a_time(double val, Action act, void **data)
{
    time_t **last = (void *)data;

    if (act == INIT)
    {
        *last = malloc(sizeof(**last));
        if (!*last)
            terminate(errno, "Malloc failed.\n");
        **last = time(NULL);
    }
    
    if (act == INSPECT)
    {
        char buf[39];
        strftime(buf, sizeof(buf), "%F %T", localtime(*last));
        printf("%38s : %-38s\n", "Stat time", buf);
        **last = time(NULL);
    }
}

void a_format(double val, Action act, void **data)
{
    if (!*data)
        terminate(0, "a_format failed, Actor.usr should be a string.\n");
    
    if (act == INSPECT)
        printf("%80s\n", (char *)*data);
}

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
void a_average(double val, Action act, void **data)
{
    AverageAccumulator **accum = (void *)data;
    
    if (act == INIT)
    {
        *accum = malloc(sizeof(**accum));
        if (!*accum)
            terminate(errno, "Malloc failed.\n");
        (*accum)->avg = 0;
        (*accum)->count = 0;
    }

    if (act == INSPECT)
    {
        printf("%38s : %-38lf\n", "Average of values", (*accum)->avg);
        (*accum)->avg = 0;
        (*accum)->count = 0;
    }

    accum_avg(*accum, val);
}

void a_deviation(double val, Action act, void **data)
{
    AverageAccumulator **accum = (void *)data;

    if (act == INIT)
    {
        *accum = malloc(2*sizeof(**accum));
        if (!*accum)
            terminate(errno, "Malloc failed.\n");
        (*accum)[0].avg = 0;
        (*accum)[1].avg = 0;
        (*accum)[0].count = 0;
        (*accum)[1].count = 0;
    }

    if (act == INSPECT)
    {
        double sq_avg = (*accum)[0].avg * (*accum)[0].avg;
        double avg_sq = (*accum)[1].avg;
        printf("%38s : %-38lf\n",
                "Standard deviation of values", sqrt(avg_sq - sq_avg));
        (*accum)[0].avg = 0;
        (*accum)[1].avg = 0;
        (*accum)[0].count = 0;
        (*accum)[1].count = 0;
    }

    accum_avg(&(*accum)[0], val);
    accum_avg(&(*accum)[1], val * val);
}
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/examples.c}}
\begin{lstlisting}
#include <stdio.h>

#include "ticker.h"
#include "stdagent.h"

// DN is a string literal of N dash '-' characters.
#define D05 "-----"
#define D20 D05 D05 D05 D05
#define D80 D20 D20 D20 D20

int main(void)
{

    // An array of Actors, each Actor is a pair of {agent, data}:
    // agent is a function, which performs the action. (you can create your own)
    // data is a void *, used to pass extra data and preserve state.
    Actor act[] =
    {   
        {a_format,   D80},          // Print a pretty line of dashes.
        {a_time,     NULL},         // Print the timestamp of earliest data.
        {a_min,      NULL},         // Print the minimum.
        {a_max,      NULL},         // Print the maximum.
        {a_sum,      NULL},         // Print the sum.
        {a_average,  NULL},         // Print the average.
        {a_deviation,NULL},         // Print the standard deviation.
        {a_format,   D80},          // Print a pretty line of dashes.
        {NULL,       NULL}          // Actors array should be null terminated.
    };

    // A TickState completely contains all the state needed for the operation
    // of tick(). That is, hypothetically, tick() is thread safe and you can
    // run multiple tickers concurrently, with each having its own TickState.
    TickState tst =
    {
        .timer = 0,                 // New timer.
        .sec_per_tick = 60,         // 60 seconds per tick.
        .actors = &act              // Add the actors we just created.
    };

    double temp;
    while (scanf("%lf", &temp) == 1)
    {
        tick(temp, &tst);
    }
}
\end{lstlisting}
\end{document}
